/**
 * 
 */
package net.bigeon.gclc.swt;

import java.io.BufferedReader;
import java.io.IOException;

import org.eclipse.swt.widgets.Label;

/**
 * @author Emmanuel Bigeon
 *
 */
public class PromptReadingRunnable implements Runnable {

    private final BufferedReader reader;
    private final Label          view;
    private boolean              running = true;

    /** @param reader the reader
     * @param view the view to update on lines. */
    public PromptReadingRunnable(final BufferedReader reader, final Label view) {
        super();
        this.reader = reader;
        this.view = view;
    }

    /* (non-Javadoc)
     * @see java.lang.Runnable#run()
     */
    @Override
    public void run() {
        String prompt;
        try {
            while (isRunning() && (prompt = reader.readLine()) != null) {
                final String curPrompt = prompt;
                view.getDisplay().syncExec(new Runnable() {
                    @Override
                    public void run() {
                        view.setText(curPrompt);
                    }
                });
            }
        } catch (final IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    /** @return the running */
    public synchronized boolean isRunning() {
        return running;
    }

    /** @param running the running to set */
    public synchronized void setRunning(final boolean running) {
        this.running = running;
    }

    /** @return the reader */
    public BufferedReader getReader() {
        return reader;
    }
}
